MODULE YorkMODULApass2SemanticErrors;
(*
*  This program contains all the semantic errors
*  which should be detected by pass2.
*
*
*  Author:
*   I.D. Cottam
*   Dept. of Computer Science,
*   University of York,
*   Heslington York England.
*
*  Date Written:
*   1978 May 17
*
*
*)

VAR scope0:char; rec0:RECORD c,d:char END; aa:ARRAY 1:1 OF char;

MODULE exportedidentinscope; DEFINE scope0; VAR scope0:char;
END    exportedidentinscope;

DEVICE MODULE mod0 [6];
 DEVICE MODULE cannotbenested [6];
 END           cannotbenested;
END           mod0;

MODULE importedidentnotdeclared; USE notdeclared;
END    importedidentnotdeclared;

MODULE exportedidentnotdeclared; DEFINE notdeclared2;
END    exportedidentnotdeclared;

CONST notcompiletimeevaluable = integer(scope0);
      badjswitchconst = (aa,scope0);

VAR duplicatedeclaration, duplicatedeclaration : integer;
    notindevicemodule[1777776B] : bits;
    notdeclared3 : undeclaredtypeident;
    identisnotatype : size;
    boundtypeerror : ARRAY 1:true OF char;
    notscalar : ARRAY [1]:[2] OF bits;
    notconstbounds : ARRAY 'a':scope0 OF boolean;

TYPE illbounds = ARRAY 1:0 OF char;
     sameidentsinenum = (same,same);
     andagain = (same,same,same);

PROCEDURE badformalarray(fa:ARRAY bits OF bits);
 BEGIN
 END      badformalarray;

MODULE setupanenvironment;
 DEFINE r, p, a, s;
VAR r:RECORD f1,f2:char END;
    a:ARRAY 1:100,'a':'z' OF bits;
    s:integer;
PROCEDURE p(x,y,z:boolean);
 BEGIN
 END      p;
END    setupanenvironment;

PROCEDURE noassignmenttoname:char;
 BEGIN
 END noassignmenttoname;

PROCEDURE assigntonamebutnotfunction;
 BEGIN 
  assigntonamebutnotfunction := '?'
 END assigntonamebutnotfunction;

PROCESS pp[32767];
 BEGIN 
    pp { ! }
 END pp;



BEGIN  {Main Program}

 varnotdeclared := 1;

(******************
 r.f1 := 'x';        {cannot access or assign}
  !! Crashes compiler !!
******************)

 a.f1 := 'x';        {not a record var}

 rec0.e := rec0.e;   {not a field}

 a[1,'a'] := a[2,'b']; {cannot subscript exported type}

 scope0 := scope0[1] ; {not an array}

 aa[1] := aa[true];    {incorrect bound type}

 thislookslikeaprocbuthasnotbeendeclared;

 aa;  {is not a proc}

 p;   {not enough params}

 pp(32767);  {process activation but should be parameterless}

 p(true,0,0);    {type mismatch}

 p(true,true,true,false);    {too many params}

 scope0 := scope0+1;         {bad op types}

 scope0 := p(true,true,true);{not a function}

 WHEN true EXIT;   {not in LOOP}

 CASE true OF
  (scope0='?') : BEGIN {not compiletime constant} END;
             1 : BEGIN {wrong type} END;
  true,true    : BEGIN {duplicate CASE labels} END
 END;

 aa := rec0;   {assign types not compatible}

 WITH aa DO {not record var} END;

 IF 1-0 THEN {not boolean} END;

 WHILE 'notboolean' DO END;

 LOOP WHEN 'notboolean' DO EXIT END;

 REPEAT  UNTIL 'notboolean';
 
 true := false;   {cannot assign}

 s := 1;          {cannot assign - read only}


 {incorrect calls of standard procs and doio}
 integer(char);
 char(integer);
 low(high);
 high(low);
 adr(1);
 size(1);

 halt(false);
 send;
 wait;
 awaited;
 inc(dec);
 dec(inc);
 doio;



END YorkMODULApass2SemanticErrors.
{
.bp
}
